/*-
 * Copyright (C)2008 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: argus1tocopy.h,v 1.2 2008/03/15 15:32:31 babolo Exp $
 */

typedef struct argus1_policy {
    u_int32_t mask;
    u_int32_t value;
    u_int32_t eq;
    u_int32_t neq;
} argus1_policy;

typedef struct argus1_traf { /* must be 64 aligned */
    u_int32_t     ru; /* 64 aligned */
    u_int32_t     ip;
    u_int32_t     category;
    u_int32_t     time;
    u_int64_t     mac;
    u_int64_t     byt;
} argus1_traf;

typedef struct argus1_addr { /* must be 64 aligned */
    u_int32_t     ip;
    u_int32_t     time;
    u_int64_t     mac;
    u_int64_t     pkt;
    u_int64_t     sent;
} argus1_addr;

typedef struct argus1_scan { /* must be 64 aligned */
    u_int32_t     ip;
    u_int32_t     time;
    u_int64_t     mac;
    u_int64_t     nrec;
} argus1_scan;

typedef struct argus1tocopy {
    u_int32_t     flags;
    u_int32_t     timask;
    size_t        nmacs;
    size_t        ltraf;
    size_t        ptraf;
    size_t        laddr;
    size_t        paddr;
    size_t        lscan;
    size_t        pscan;
    int           pluspacket;
    FILE         *itraf;
    FILE         *iaddr;
    FILE         *iscan;
    u_int64_t    *maclist;
    argus1_policy*policy;
    argus1_traf **btraf;
    argus1_addr **baddr;
    argus1_scan **bscan;
} argus1tocopy;

int       argus1_MAClist __P((argus1tocopy *opts, char *macfile));
u_int32_t argus1_policer __P((argus1tocopy *opts, u_int32_t ip));
int       argus1_decode  __P((argus1tocopy *opts, void *next));
void      argus1_rollout __P((argus1tocopy *opts));
void      argus1_polout  __P((argus1tocopy *opts, int c));
